/*****************************************************************************\
*
* create.cpp
*
* create - space object creator class
*
* Authors: Petr Bulek (xbulic00 _AT stud.fit.vutbr.cz)
* PCJohn (peciva _AT fit.vutbr.cz)
* Contributors:
*
* ----------------------------------------------------------------------------
*
* THIS SOFTWARE IS NOT COPYRIGHTED
*
* This source code is offered for use in the public domain.
* You may use, modify or distribute it freely.
*
* This source code is distributed in the hope that it will be useful but
* WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
* DISCLAIMED. This includes but is not limited to warranties of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* If you find the source code useful, authors will kindly welcome
* if you give them credit and keep their names with their source code,
* but do not feel to be forced to do so.
*
\*****************************************************************************/





#ifdef _WIN32	
	#include <Inventor/Win/SoWin.h>
	#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
	#include <Inventor/Win/viewers/SoWinFlyViewer.h>
#else
	#include <Inventor/Qt/SoQt.h>
	#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
	#include <Inventor/Qt/viewers/SoQtFlyViewer.h>
#endif

#include <Inventor/nodes/SoEnvironment.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoComplexity.h>
#include <Inventor/nodes/SoPointLight.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransformSeparator.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoBumpMap.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoLOD.h>
#include <Inventor/nodes/SoInfo.h>
#include <Inventor/nodes/SoLevelOfDetail.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/engines/SoComposeVec3f.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/nodes/SoTriangleStripSet.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoIndexedTriangleStripSet.h>

#include <Inventor/SbLinear.h>
#include <Inventor/SbBSPTree.h>



#include <math.h>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <string>
#include <vector>
#include <cctype>
#include <stdio.h>

#include "create.h"

#define PI 3.14159265



void create::randomize(vector<point> &px, int x)
{
	float pom = 0;

	polomer = 1000 - float(x)/2;
	if (polomer < 500) polomer = 500;

	
	if (x != 0) 
	{	
		for (int i = px.size(); i<p.size(); i++)
		{
			r = polomer + rand()%x;
			r = r/1000;
		
			bod.x = p[i].x;
			bod.y = p[i].y;
			bod.z = p[i].z;

			pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);		
			pom = radius / pom;		

			bod.x = (bod.x * pom) ;
			bod.y = (bod.y * pom) ;
			bod.z = (bod.z * pom) ;		
		
			bod1.x = bod.x * r;
			bod1.y = bod.y * r;
			bod1.z = bod.z * r;

			bod1.x = bod1.x - bod.x;
			bod1.y = bod1.y - bod.y;
			bod1.z = bod1.z - bod.z;		
			
			bod.x = p[i].x + bod1.x;
			bod.y = p[i].y + bod1.y;
			bod.z = p[i].z + bod1.z;

			px.push_back(bod);		
		};
	}
	else px = p;
};


SoSeparator* create::buildShape()
{
        SoSeparator *root = new SoSeparator;

        int counter = 0;
        int size = int(pointer_zal.size())/3;

		SoCoordinate3 *co = new SoCoordinate3;
        SoTriangleStripSet *strip = new SoTriangleStripSet;

        for (int i = 0; i<size; i++)
        {
			co->point.set1Value(counter+0, p[pointer[counter]].x,
						                   p[pointer[counter]].y,
										   p[pointer[counter]].z);
			co->point.set1Value(counter+1, p[pointer[counter+1]].x,
										   p[pointer[counter+1]].y,
										   p[pointer[counter+1]].z);
			co->point.set1Value(counter+2, p[pointer[counter+2]].x,
										   p[pointer[counter+2]].y,
										   p[pointer[counter+2]].z);
			strip->numVertices.set1Value(i, 3);

            counter = counter + 3;
        };

		root->addChild(co);
        root->addChild(strip);
        return root;
};


void create::shift(point p1)
{
	double pom = 0;
	bool is_in_p = false;
	int pozice = 0;


	//zaokrouhleni (kvuli porovnavani ve vektoru)
	p1.x = int(p1.x * 1000);
	p1.x = p1.x/1000;
	p1.y = int(p1.y * 1000);
	p1.y = p1.y/1000;
	p1.z = int(p1.z * 1000);
	p1.z = p1.z/1000;


	pom_bod->setValue(p1.x,p1.y,p1.z);

	out = tree->findPoint(*pom_bod);
	if (out > -1) is_in_p = true;



	if (!is_in_p)
	{
		tree->addPoint(*pom_bod);
		p.push_back(p1);
		pointer_zal.push_back(p.size()-1);
	}
	//else pointer_zal.push_back(pozice);
	else pointer_zal.push_back(out);

};

void create::normal(point &bod, int counter1, int counter2)
{
    float len;
    float avgHeight;
		bod.x = (p[pointer[counter1]].x + p[pointer[counter2]].x)/2;
		bod.y = (p[pointer[counter1]].y + p[pointer[counter2]].y)/2;
		bod.z = (p[pointer[counter1]].z + p[pointer[counter2]].z)/2;
    avgHeight = (sqrt(p[pointer[counter1]].x * p[pointer[counter1]].x +
                      p[pointer[counter1]].y * p[pointer[counter1]].y +
                      p[pointer[counter1]].z * p[pointer[counter1]].z) +
                 sqrt(p[pointer[counter2]].x * p[pointer[counter2]].x +
                      p[pointer[counter2]].y * p[pointer[counter2]].y +
                      p[pointer[counter2]].z * p[pointer[counter2]].z)) / 2;
		len = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
		bod.x *= avgHeight/len;
		bod.y *= avgHeight/len;
		bod.z *= avgHeight/len;
};


SoSeparator* create::divide()
{
	SoSeparator *root = new SoSeparator;

	int counter = 0;
	int pomoc0 = 0;
	int pomoc1 = 0;
	int pomoc2 = 0;    
	int size = pointer.size();
	pointer_zal.clear();

	while (counter < size)
	{
		pomoc.clear();

   		normal(bod, counter, counter+1);
    	pomoc.push_back(bod);

    	normal(bod, counter, counter+2);
    	pomoc.push_back(bod);

    	normal(bod, counter+2, counter+1);
    	pomoc.push_back(bod);
		

		pointer_zal.push_back(pointer[counter]);
		shift(pomoc[0]);
		shift(pomoc[1]);

		shift(pomoc[0]);
		pointer_zal.push_back(pointer[counter+1]);
		shift(pomoc[2]);

		shift(pomoc[1]);
		shift(pomoc[2]);
		pointer_zal.push_back(pointer[counter+2]);

		shift(pomoc[1]);
		shift(pomoc[0]);
		shift(pomoc[2]);


		counter = counter + 3;
	};

	pointer.clear();
	pointer = pointer_zal;

	return root;
};


SoNode* create::display()
{
  SoGroup *root;

	if (lod)
	{
		SoLOD *lod = new SoLOD;
		lod->center.setValue(0, 0, 0);
		lod->range.set1Value(0,50);
		lod->range.set1Value(1,130);
		lod->range.set1Value(2,280);
		lod->range.set1Value(3,550);
		lod->range.set1Value(4,850);
		lod->range.set1Value(5,945);
		root = lod;
  } else {
		SoLevelOfDetail *level = new SoLevelOfDetail;
		level->screenArea.set1Value(0,75000);
		level->screenArea.set1Value(1,18000);
		level->screenArea.set1Value(2,1500);
		level->screenArea.set1Value(3,500);
		level->screenArea.set1Value(4,60);
		level->screenArea.set1Value(5,10);
		root = level;
  };

///////////////////////////////JEHHLAN JAKO NEJMENSI DETAIL///////////////////////////////////////////////////////
//	lod->insertChild(createPyramid(),0);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////


		SoInfo *nic = new SoInfo;
		root->insertChild(nic,0);



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////STACI MENIT NA JEDNOM MISTE ///////////////////////////////////////////////////////
////////////////////////////Doporuceni: idealni rozsah promenne rozptyl <je 0 - 1000>/////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		//rozptyl =0;
		float delitel = 2;


		initiate();
		randomize(p1,rozptyl);
		rozptyl = rozptyl/delitel;
		p = p1;		
		root->insertChild(buildShape(),0);


		p2 = p;
		divide();		
		randomize(p2,rozptyl);			
		rozptyl = rozptyl/delitel;
		p = p2;		
		root->insertChild(buildShape(),0);

		p3 = p;
		divide();		
		randomize(p3,rozptyl);
		rozptyl = rozptyl/delitel;
		p = p3;		
		root->insertChild(buildShape(),0);

		
		p4 = p;
		divide();		
		randomize(p4,rozptyl);
		rozptyl = rozptyl/delitel;
		p = p4;		
		root->insertChild(buildShape(),0);

		p5 = p;
		divide();		
		randomize(p5,rozptyl);
		rozptyl = rozptyl/delitel;
		p = p5;		
		root->insertChild(buildShape(),0);

		p6 = p;
		divide();		
		randomize(p6,rozptyl);
		rozptyl = rozptyl/delitel;
		p = p6;		
		root->insertChild(buildShape(),0);

		p7 = p;
		divide();		
		randomize(p7,rozptyl);
		rozptyl = rozptyl/delitel;
		p = p7;		
		root->insertChild(buildShape(),0);


	return root;
};


void create::initiate()
{
	double posuv_x = 0;
	double posuv_z = 0;
	double posuv_y = 0;

	double rad = radius;
	double x = 0;
	double y = 0;
	double z = 0;

	double pom = 0;
	int pozice = 0;
	int dve = 2;

	posuv_x = rad*sin(45*PI/180);
	posuv_z = posuv_x;
	posuv_y = posuv_x;


	bod.x = x-posuv_x;
	bod.y = y;
	bod.z = z+posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue(bod.x,bod.y,bod.z);
	tree->addPoint(*pom_bod);


	bod.x = x+posuv_x;
	bod.y = y;
	bod.z = z+posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue(bod.x,bod.y,bod.z);
	tree->addPoint(*pom_bod);


	bod.x = x+posuv_x;
	bod.y = y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue(bod.x,bod.y,bod.z);
	tree->addPoint(*pom_bod);


	bod.x = x-posuv_x;
	bod.y = y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue(bod.x,bod.y,bod.z);
	tree->addPoint(*pom_bod);



	bod.x = x;
	bod.y = y + posuv_y;
	bod.z = z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue(bod.x,bod.y,bod.z);
	tree->addPoint(*pom_bod);



	bod.x = x;
	bod.y = y - posuv_y;
	bod.z = z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue(bod.x,bod.y,bod.z);
	tree->addPoint(*pom_bod);



	pointer.push_back(0);
	pointer.push_back(1);
	pointer.push_back(4);

	pointer.push_back(1);
	pointer.push_back(2);
	pointer.push_back(4);

	pointer.push_back(2);
	pointer.push_back(3);
	pointer.push_back(4);

	pointer.push_back(3);
	pointer.push_back(0);
	pointer.push_back(4);



	pointer.push_back(0);
	pointer.push_back(5);
	pointer.push_back(1);

	pointer.push_back(1);
	pointer.push_back(5);
	pointer.push_back(2);

	pointer.push_back(2);
	pointer.push_back(5);
	pointer.push_back(3);

	pointer.push_back(3);
	pointer.push_back(5);
	pointer.push_back(0);

	pointer_zal = pointer;
};



SoSeparator* create::createPyramid()
{
	SoSeparator *root = new SoSeparator;

	double posuv_x = 0;
	double posuv_z = 0;
	double posuv_y = 0;

	double pom = 0;
	int pozice = 0;

	double rad = radius;
	double x = 0;
	double y = 0;
	double z = 0;

	posuv_x = rad*cos(30*PI/180);
	posuv_z = rad*sin(30*PI/180);
	posuv_y = posuv_z*sin(60*PI/180);


	bod.x = x-posuv_x;
	bod.y = y-posuv_y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);


	bod.x = x+posuv_x;
	bod.y = y-posuv_y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);

	bod.x = x;
	bod.y = y-posuv_y;
	bod.z = z+2*posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);

	bod.x = x;
	bod.y = y+2*posuv_y;
	bod.z =z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);


	SoTriangleStripSet *troj;
    SoCoordinate3 *coor;

	coor = new SoCoordinate3;

	coor->point.set1Value(0,p[0].x,p[0].y,p[0].z);
	coor->point.set1Value(1,p[1].x,p[1].y,p[1].z);
	coor->point.set1Value(2,p[2].x,p[2].y,p[2].z);
	coor->point.set1Value(3,p[3].x,p[3].y,p[3].z);
	coor->point.set1Value(4,p[0].x,p[0].y,p[0].z);
	coor->point.set1Value(5,p[1].x,p[1].y,p[1].z);

	root->addChild(coor);

	troj = new SoTriangleStripSet;
	troj->numVertices.setValue(6);
	root->addChild(troj);


	p.clear();

	return root;
};



SoSeparator* create::createObject(double rad, int roz)
{
	SoSeparator *root = new SoSeparator;
	
	radius = rad;
	rozptyl = roz;
	root->addChild(display());

	return root;
};




//////////////////////  KONSTRUKTORY/DESTRUKTORY  //////////////////////
create::create()
{

	lod = false;	
	out = 0;  //pomocna promena pro prohledavani stromu	
	
	pom_bod = new SbVec3f;

	tree = new SbBSPTree;
/*	tree1 = new SbBSPTree;
	tree2 = new SbBSPTree;
	tree3 = new SbBSPTree;
	tree4 = new SbBSPTree;
	tree5 = new SbBSPTree;
	tree6 = new SbBSPTree;*/
	
	
};
create::~create() {
};






int main(int argc, char *argv[])
{
	#ifdef _WIN32
		// wokna
  		HWND window = SoWin::init(argv[0]);
	#else
		//linux
  		QWidget *window = SoQt::init(argv[0]);
  		if (window == NULL) exit(1);
	#endif


	// generovani nahodnych cisel
	srand( (unsigned)time( NULL ) );

  	// koren sceny
  	SoSeparator *root = new SoSeparator;
  	root->ref();

	//Material
	SoMaterial *material = new SoMaterial;
	material->diffuseColor.setValue(1.0, 0.0, 0.0);
	root->addChild(material);


	
	
	create teleso;
	root->addChild(teleso.createObject(2,900));




	#ifdef _WIN32
		// okno prohlizece
  		SoWinExaminerViewer *viewer = new SoWinExaminerViewer(window);
  		//SoWinFlyViewer *viewer = new SoWinFlyViewer(window);
	#else
		// okno prohlizece
  		SoQtExaminerViewer *viewer = new SoQtExaminerViewer(window);
  		//SoQtFlyViewer *viewer = new SoQtFlyViewer(window);
	#endif

  	viewer->setSceneGraph(root);
  	viewer->setTitle("Deleni trojuhelniku");
  	//viewer->setHeadlight(TRUE);
  	viewer->show();



	#ifdef _WIN32
		// renderovaci smycka
  		SoWin::show(window);
  		SoWin::mainLoop();
	#else
		// renderovaci smycka
  		SoQt::show(window);
  		SoQt::mainLoop();
	#endif



  	// uvolneni pameti
  	delete viewer;
  	root->unref();

  	return 0;

};
